/*
	this file defines constants for the dObject BGI system
*/

% GRAPHICS DRIVERS
#define DETECT 0
#define CGA 1
#define MCGA 2
#define EGA 3
#define EGA64   4
#define EGAMONO   5
#define RESERVED   6
#define HERCMONO   7
#define ATT400   8
#define VGA   9
#define PC3270  10


% GRAPHICS MODES FOR EACH DRIVER
#define CGAC0       0  /* 320X200 COLOR PALETTE 0: RED, YELLOW, GREEN, 1 PAGE */
#define CGAC1       1  /* 320X200 COLOR PALETTE 1: CYAN, MAGENTA, WHITE, 1 PG */
#define CGAC2       2  /* 320X200 COLOR PALETTE 2:    */
#define CGAC3       3  /* 320X200 COLOR PALETTE 3:    */
#define CGAHI       4  /* 640X200 1 PAGE    */
#define MCGAC0      0  /* 320X200 COLOR PALETTE 0: RED, YELLOW, GREEN, 1 PAGE */
#define MCGAC1      1  /* 320X200 COLOR PALETTE 1: CYAN, MAGENTA, WHITE, 1 PG */
#define MCGAC2      2  /* 320X200 COLOR PALETTE 2:    */
#define MCGAC3      3  /* 320X200 COLOR PALETTE 3:    */
#define MCGAMED     4  /* 640X200 1 PAGE    */
#define MCGAHI      5  /* 640X480 2 COLOR 1 PAGE    */
#define EGALO       0  /* 640X200 4 PAGES    */
#define EGAHI       1  /* 640X350 16 COLOR 2 PAGES    */
#define EGA64LO     0  /* 640X200 16 COLOR 1 PAGE    */
#define EGA64HI     1  /* 640X350 4 COLOR 1 PAGE    */
#define EGAMONOHI   3  /* 640X350 64K ON CARD, 1 PAGE - 256K ON CARD, 4 PAGES */
#define HERCMONOHI  0  /* 720X348 2 PAGES    */
#define ATT400C0    0  /* 320X200 COLOR PALETTE 0: RED, YELLOW, GREEN, 1 PAGE */
#define ATT400C1    1  /* 320X200 COLOR PALETTE 1: CYAN, MAGENTA, WHITE, 1 PG */
#define ATT400C2    2  /* 320X200 COLOR PALETTE 2:    */
#define ATT400C3    3  /* 320X200 COLOR PALETTE 3:    */
#define ATT400MED   4  /* 640X200 1 PAGE    */
#define ATT400HI    5  /* 640X400 1 PAGE    */
#define VGALO       0  /* 640X200 16 COLOR 4 PAGES    */
#define VGAMED      1  /* 640X350 16 COLOR 2 PAGES    */
#define VGAHI       2  /* 640X480 16 COLOR 1 PAGE    */
#define VGAHI2      3  /* 640X480 2 COLOR 1 PAGE    */
#define PC3270HI    0  /* 720X350 1 PAGE    */


% COLORS FOR SETPALETTE AND SETALLPALETTE
#define BLACK 0 /* DARK COLORS */
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define MAGENTA 5
#define BROWN 6
#define LIGHTGRAY 7
#define DARKGRAY 8 /* LIGHT COLORS */
#define LIGHTBLUE 9
#define LIGHTGREEN 10
#define LIGHTCYAN 11
#define LIGHTRED 12
#define LIGHTMAGENTA 13
#define YELLOW 14
#define WHITE 15


% LINE STYLES FOR GET/SETLINESTYLE
#define SOLID_LINE    0
#define DOTTED_LINE   1
#define CENTER_LINE   2
#define DASHED_LINE   3
#define USERBIT_LINE  4 /* USER DEFINED LINE STYLE */


% LINE WIDTHS FOR GET/SETLINESTYLE
#define NORM_WIDTH 1
#define THICK_WIDTH 3

% FONTS
#define DEFAULT_FONT 0/* 8X8 BIT MAPPED FONT */
#define TRIPLEX_FONT 1/* "STROKED" FONTS */
#define SMALL_FONT 2
#define SANS_SERIF_FONT 3
#define GOTHIC_FONT 4


% WRITING DIRECTION
#define HORIZ_DIR 0 /* LEFT TO RIGHT */
#define VERT_DIR 1 /* BOTTOM TO TOP */

% NAMING OF USER DEFINED CHARSIZE IN SETTEXTSTYLE
#define USER_CHAR_SIZE 0 /* USER-DEFINED CHAR SIZE */


% FILL PATTERNS FOR GET/SETFILLSTYLE
#define EMPTY_FILL 0 /* FILLS AREA IN BACKGROUND COLOR */
#define SOLID_FILL 1 /* FILLS AREA IN SOLID FILL COLOR */
#define LINE_FILL 2 /* --- FILL */
#define LTSLASH_FILL 3 /* /// FILL */
#define SLASH_FILL 4 /* /// FILL WITH THICK LINES */
#define BKSLASH_FILL 5 /* \\\ FILL WITH THICK LINES */
#define LTBKSLASH_FILL 6 /* \\\ FILL */
#define HATCH_FILL 7 /* LIGHT HATCH FILL */
#define XHATCH_FILL 8 /* HEAVY CROSS HATCH FILL */
#define INTERLEAVE_FILL 9 /* INTERLEAVING LINE FILL */
#define WIDE_DOT_FILL 10 /* WIDELY SPACED DOT FILL */
#define CLOSE_DOT_FILL 11 /* CLOSELY SPACED DOT FILL */
#define USER_FILL 12 /* USER DEFINED FILL */


% BITBLT OPERATORS FOR PUTIMAGE AND WRITEMODE
#define COPY_PUT 0
#define XOR_PUT 1
#define OR_PUT 2
#define AND_PUT 3
#define NOT_PUT 4


% HORIZONTAL AND VERTICAL JUSTIFICATION FOR SETTEXTJUSTIFY
#define LEFT_TEXT 0
#define CENTER_TEXT 1
#define RIGHT_TEXT 2

#define BOTTOM_TEXT 0
#define TOP_TEXT 2


% CLIPPING IN A VIEWPORT
#define  CLIP 1
#define  NOCLIP 0


% DEFINE SOME HANDY CONSTANTS
#define  PI "3.14159"
